/* ---------- timer.c --------------- */
#include <stdio.h>
#include <dos.h>
#include "timer.h"
#include "interupt.h"

unsigned ticker;

/* static void (interrupt far *old_timer)(void); */
static void interrupt far (*old_timer)(void);
static void interrupt far new_timer(void);
static void (*time_out_function)(void);

/* ---- intercept the timer interrupt vector ----- */
void intercept_timer(void (*fn)(void))
{
  if (old_timer == NULL)
    {
      old_timer = getvect(TIMER);
      setvect(TIMER, new_timer);
    }
	time_out_function = fn;
}

/* ---- restore timer interrupt vector ------- */
void restore_timer()
{
  if (old_timer != NULL)
    setvect(TIMER, old_timer);
	time_out_function = NULL;
}

/* ------ ISR to count timer ticks ------- */
static void interrupt far new_timer()
{
  (*old_timer)();
  if (ticker > 0)
    if (--ticker == 0 && time_out_function != NULL)
      (*time_out_function)();
}
